#if 0
#include <simpletools.h>

#define MISO            1
#define SCLK            2
#define MOSI            0
#define CS              4
#else
#include <stdio.h>
#include <propeller.h>

extern _Driver _SimpleSerialDriver;
extern _Driver _FileDriver;
#endif

int createTestFile ();

_Driver *_driverlist[] = {
&_SimpleSerialDriver,
&_FileDriver,
NULL
};

const char textForFile[] = "Testing 123...Add extra data...\n";


int main () {
    char s[15], t[15];
    int  position;
    int err;
    FILE *fp;

    waitcnt(CLKFREQ+CNT);

#if 0
    if ((err = sd_mount(MISO, SCLK, MOSI, CS))) {
        printf("Error mounting SD card: %d. Now exiting.\n", err);
        return 1;
    }
#endif

    // Create a test file. Exit if it failed
    if (createTestFile())
        return 1;


    // Open file for read
    printf("Opening file for Read\n");
    fp = fopen("new1.raw", "rb");
    if (fp == NULL) {
        printf("ERROR opening file for Read\n");
        return 1;
    }


    // Read some bytes from the file
    position = ftell(fp);
    printf("\nPosition at start: %d\n", position);
    fread(s, 1, 15, fp);
    printf("Read data from file: \"%s\"\n", s);
    printf("Now current position is %d\n", ftell(fp));


    // Seek to end
    printf("\nSeeking to end\n");
    if ((err = fseek(fp, 0, SEEK_END))) {
        printf("Error during seek: %d\n", err);
        return 1;
    }
    position = ftell(fp);
    printf("Now current position is %d\n", position);


    //shouldn't get good data here...I'm past END
    if ((err = fread(t, 1, 15, fp))) {
        printf("\nWas not expecting to read anything. Instead, read %d bytes\n",
              err);
        printf("Read data from file: \"%s\"\n", t);
    } else
        printf("\nNo data expected and no data read. That's good.\n");


    printf("\nRewinding\n");
    rewind(fp);
    printf("Now current position is %d\n", ftell(fp));
    fread(t, 1, 15, fp);
    //Now I get good data, which is correct.
    printf("Read file data after rewind: \"%s\"\n", t);
    printf("Now current position is %d\n", ftell(fp));


    return 0;
}


int createTestFile () {// Attempt to open file
    printf("Open file for writing\n");
    FILE *fp = fopen("new1.raw", "wb");
    if (fp == NULL) {
        printf("ERROR opening file fro Write\n");
        return 1;
    }


    // Write some stuff to the file
    printf("Write to file\n");
    fwrite(textForFile, 1, sizeof(textForFile), fp);


    // Close the file
    printf("Closing file\n");
    fclose(fp);


    return 0;
}